de.caff.generics.function

## Interface VarBooleanOperator

- Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface VarBooleanOperator

  Primitive boolean operator with a variable number of arguments.

  Although this basically works for a variable boolean array via the `apply(boolean...)` method implementors have to implement the method `apply(BooleanIndexable)` with a `BooleanIndexable` argument. This is done to make this class generally more useful without the need to copy arrays.

  Since:
    November 03, 2020
  Author:
    Rammi

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default boolean` | `apply(boolean... values)` Apply this operator.
    `boolean` | `apply(BooleanIndexable values)` Apply this operator.
    `static VarBooleanOperator` | `fromBinary(BooleanOperator2 binaryOp, boolean startValue)` Create an variable args operator from applying a binary operator over and over.

- - ### Method Detail

    - #### apply

          default boolean apply(boolean... values)

      Apply this operator. This default method forwards execution to `apply(BooleanIndexable)`.
      Parameters:
        `values` - arguments on which this operator is applied
      Returns:
        result of applying this operator to all arguments

    - #### apply

          boolean apply(@NotNull
                        BooleanIndexable values)

      Apply this operator.
      Parameters:
        `values` - indexable providing the values on which this operator operates
      Returns:
        result of applying this operator to all values

    - #### fromBinary

          @NotNull
          static VarBooleanOperator fromBinary(@NotNull
                                                        BooleanOperator2 binaryOp,
                                                        boolean startValue)

      Create an variable args operator from applying a binary operator over and over.

      Eg

           VarBooleanOperator parityOp = VarBooleanOperator.fromBinary((b1, b2) -> b1 ^ b2, false);
           boolean parity = parityOp.apply(true, false, false, true);

      On each application the currently accumulated result becomes the left (first) argument of `binaryOp`, while the run value becomes the right (second).
      Parameters:
        `binaryOp` - binary operator
        `startValue` - start value (result of operator if no values are given)
      Returns:
        variable boolean argument operator which applies the given binary operator over and over